﻿using ProjectBoat.Entities;

namespace ProjectBoat.Drawnings
{
    public static class ExtentionDrawningBoat
    {
        /// <summary>
        /// Разделитель для записи информации по объекту в файл
        /// </summary>
        private static readonly string _separatorForObject = ":";

        /// <summary>
        /// Создание объекта из строки
        /// </summary>
        /// <param name="info">Строка с данными для создания объекта</param>
        /// <returns>Объект</returns>
        public static DrawningBoat? CreateDrawningBoat(this string info)
        {
            string[] strs = info.Split(_separatorForObject);
            EntityBoat? boat = EntityMBoat.CreateEntityMBoat(strs);
            if (boat != null)
            {
                return new DrawningMBoat(boat);
            }

            boat = EntityBoat.CreateEntityBoat(strs);
            if (boat != null)
            {
                return new DrawningBoat(boat);
            }
            return null;
        }

        /// <summary>
        /// Получение данных для сохранения в файл
        /// </summary>
        /// <param name="drawningBoat">Сохраняемый объект</param>
        /// <returns>Строка с данными по объекту</returns>
        public static string GetDataForSave(this DrawningBoat drawningBoat)
        {
            string[]? array = drawningBoat?.EntityBoat?.GetStringRepresentation();
            if (array == null)
            {
                return string.Empty;
            }
            return string.Join(_separatorForObject, array);
        }

    }
}
