﻿namespace ProjectBoat.Entities
{
    internal class EntityMBoat : EntityBoat
    {
        /// <summary>
        /// Признак (опция) наличие вертолетной площадки
        /// </summary>
        public bool Motor { get; private set; }
        /// <summary>
        /// Признак (опция) наличие шлюпок
        /// </summary>
        public bool Oars { get; private set; }
        /// <summary>
        /// Признак (опция) наличие пушки
        /// </summary>
        public bool Glass { get; private set; }
        /// <summary>
        /// Дополнительный цвет (для опциональных элементов)
        /// </summary>
        public Color AdditionalColor { get; private set; }
        public void setAdditionalColor(Color color)
        {
            AdditionalColor = color;
        }
        public EntityMBoat(int speed, double weight, Color bodyColor, Color additionalColor, bool motor, bool oars, bool glass) : base(speed, weight, bodyColor)
        {
            AdditionalColor = additionalColor;
            Motor = motor;
            Oars = oars;
            Glass = glass;
        }
        /// <summary>
        /// Получение строк со значениями свойств объекта класса-сущности
        /// </summary>
        /// <returns></returns>
        public override string[] GetStringRepresentation()
        {
            return new[] { nameof(EntityBoat), Speed.ToString(), Weight.ToString(), BodyColor.Name, AdditionalColor.Name,
            Motor.ToString(), Oars.ToString(), Glass.ToString() };
        }

        /// <summary>
        /// Создание объекта из массива строк
        /// </summary>
        /// <param name="strs"></param>
        /// <returns></returns>
        public static EntityBoat? CreateEntityMBoat(string[] strs)
        {
            if (strs.Length != 8 || strs[0] != nameof(EntityBoat))
            {
                return null;
            }
            return new EntityMBoat(Convert.ToInt32(strs[1]), Convert.ToDouble(strs[2]), Color.FromName(strs[3]), Color.FromName(strs[4]),
                Convert.ToBoolean(strs[5]), Convert.ToBoolean(strs[6]), Convert.ToBoolean(strs[7]));
        }
    }
}
 
